#include <p18f452.h>
#include <usart.h>
#include <delays.h>

#define	LEDR0	PORTDbits.RD2
#define	LEDI0	PORTDbits.RD3
#define	LEDR1	PORTDbits.RD0
#define	LEDI1	PORTDbits.RD1
#define	LEDR2	PORTCbits.RC2
#define	LEDI2	PORTCbits.RC3
#define	LEDR3	PORTCbits.RC0
#define	LEDI3	PORTCbits.RC1
#define	LEDR4	PORTEbits.RE0
#define	LEDI4	PORTEbits.RE1
#define	LEDR5	PORTAbits.RA4
#define	LEDI5	PORTAbits.RA5
#define	LEDR6	PORTAbits.RA2
#define	LEDI6	PORTAbits.RA3
#define	LEDR7	PORTAbits.RA0
#define	LEDI7	PORTAbits.RA1
#define	LEDR8	PORTBbits.RB5
#define	LEDI8	PORTBbits.RB4
#define	LEDR9	PORTBbits.RB7
#define	LEDI9   PORTBbits.RB6

char c[10];
int i,j,liaison,numled;
int tempsledr,tempsledi,c3,c4,c5,c6,c7,c8;

void rx_handler (void);
void init (void);
int recupc1 (char);
int recupc2 (char);
int recupc3 (char);
void connec (void);
void leds (void);
void off (void);

#pragma code rx_interrupt = 0x8
void rx_int (void)
{
  _asm goto rx_handler _endasm
}
#pragma code

#pragma interrupt rx_handler
void rx_handler (void)
{
//  while (!DataRdyUSART());
  c[i] = ReadUSART();
  i=i+1;
  if (i==10)
	{
	i=1;
	liaison = 1;
	}
  
     /* Clear the interrupt flag */
  PIR1bits.RCIF = 0;
}


void main (void)
{
  init();
  /* Loop forever */
  while (1)
    {
	connec();
	leds();
	}
}

void init (void)
{
  /* Configure all PORTB pins for output */
  TRISA = 0;
  TRISB = 0;
  TRISC = 0;
  TRISD = 0;
  TRISE = 0;

  /*
   * Open the USART configured as
   * 8N1, 2400 baud, in polled mode
   */
  OpenUSART (USART_TX_INT_OFF &
             USART_RX_INT_ON &
             USART_ASYNCH_MODE &
             USART_EIGHT_BIT &
             USART_CONT_RX &
             USART_BRGH_HIGH, 103);
 
  /* Enable interrupt priority */
  RCONbits.IPEN = 1;

  /* Make receive interrupt high priority */
  IPR1bits.RCIP = 1;

  /* Enable all high priority interrupts */
  INTCONbits.GIEH = 1;

	off();
	liaison = 0;
	numled = 11;
	i=1;
}

int recupc1(char c)
{
switch (c)
	{
	case '0' : return (0);
	case '1' : return (100);
	case '2' : return (200);
	case '3' : return (300);
	case '4' : return (400);
	case '5' : return (500);
	case '6' : return (600);
	case '7' : return (700);
	case '8' : return (800);
	case '9' : return (900);
	}
}

int recupc2(char c)
{
switch (c)
	{
	case '0' : return (0);
	case '1' : return (10);
	case '2' : return (20);
	case '3' : return (30);
	case '4' : return (40);
	case '5' : return (50);
	case '6' : return (60);
	case '7' : return (70);
	case '8' : return (80);
	case '9' : return (90);
	}
}

int recupc3(char c)
{
switch (c)
	{
	case '0' : return (0);
	case '1' : return (1);
	case '2' : return (2);
	case '3' : return (3);
	case '4' : return (4);
	case '5' : return (5);
	case '6' : return (6);
	case '7' : return (7);
	case '8' : return (8);
	case '9' : return (9);
	}
}

void off (void)
{
	LEDR0 = 0;
	LEDI0 = 0;
	LEDR1 = 0;
	LEDI1 = 0;
	LEDR2 = 0;
	LEDI2 = 0;
	LEDR3 = 0;
	LEDI3 = 0;
	LEDR4 = 0;
	LEDI4 = 0;
	LEDR5 = 0;
	LEDI5 = 0;
	LEDR6 = 0;
	LEDI6 = 0;
	LEDR7 = 0;
	LEDI7 = 0;
	LEDR8 = 0;
	LEDI8 = 0;
	LEDR9 = 0;
	LEDI9 = 0;
}

void connec (void)
{
if (liaison == 1)
	{
		off();
		
		if (c[1] == 'x')
   		 {
   		   numled = 11;
		   off();
 		 }
		else if (c[1] == 'a')
  	     {
     	    if (c[2] == '1')
				{
				numled = 0;
				}
			else if (c[2] == '2')
				{
				numled = 10;
				}
         }
		else if (c[1] == 'l')
  	     {
			switch(c[2])
				{
					case '1': numled = 1; break;
					case '2': numled = 2; break;
					case '3': numled = 3; break;
					case '4': numled = 4; break;
					case '5': numled = 5; break;
					case '6': numled = 6; break;
					case '7': numled = 7; break;
					case '8': numled = 8; break;
					case '9': numled = 9; break;
				}
         }
		if (numled != 11)
			{
			c3 = recupc1(c[3]);
			c4 = recupc2(c[4]);
			c5 = recupc3(c[5]);
			c6 = recupc1(c[6]);
			c7 = recupc2(c[7]);
			c8 = recupc3(c[8]);
			tempsledr = c3 + c4 + c5;
			tempsledi = c6 + c7 + c8;
			}
	liaison=0;
	}
}

void leds (void)
{
if (numled != 11)
	{
	if (numled == 0)
		{
		LEDI0 = 0;
		LEDR0 = 1;
		for (j=0; j<tempsledr; j++)
			{
			if (liaison == 1)
				{
				j=tempsledr;
				}	
			Delay10KTCYx(100);
			}
		LEDR0 = 0;
		LEDI0 = 1;
		for (j=0; j<tempsledi; j++)
			{
			if (liaison == 1)
				{
				j=tempsledi;
				}
			Delay10KTCYx(100);
			}
		}
	else if (numled == 1)
		{
		LEDI1 = 0;
		LEDR1 = 1;
		for (j=0; j<tempsledr; j++)
			{
			if (liaison == 1)
				{
				j=tempsledr;
				}
			Delay10KTCYx(100);
			}
		LEDR1 = 0;
		LEDI1 = 1;
		for (j=0; j<tempsledi; j++)
			{
			if (liaison == 1)
				{
				j=tempsledi;
				}	
			Delay10KTCYx(100);
			}
		}
	else if (numled == 2)
		{
		LEDI2 = 0;
		LEDR2 = 1;
		for (j=0; j<tempsledr; j++)
			{
			if (liaison == 1)
				{
				j=tempsledr;
				}	
			Delay10KTCYx(100);
			}
		LEDR2 = 0;
		LEDI2 = 1;
		for (j=0; j<tempsledi; j++)
			{
			if (liaison == 1)
				{
				j=tempsledi;
				}	
			Delay10KTCYx(100);
			}
		}
	else if (numled == 3)
		{
		LEDI3 = 0;
		LEDR3 = 1;
		for (j=0; j<tempsledr; j++)
			{
			if (liaison == 1)
				{
				j=tempsledr;
				}	
			Delay10KTCYx(100);
			}
		LEDR3 = 0;
		LEDI3 = 1;
		for (j=0; j<tempsledi; j++)
			{
			if (liaison == 1)
				{
				j=tempsledi;
				}	
			Delay10KTCYx(100);
			}
		}
	else if (numled == 4)
		{
		LEDI4 = 0;
		LEDR4 = 1;
		for (j=0; j<tempsledr; j++)
			{
			if (liaison == 1)
				{
				j=tempsledr;
				}	
			Delay10KTCYx(100);
			}
		LEDR4 = 0;
		LEDI4 = 1;
		for (j=0; j<tempsledi; j++)
			{
			if (liaison == 1)
				{
				j=tempsledi;
				}	
			Delay10KTCYx(100);
			}
		}
	else if (numled == 5)
		{
		LEDI5 = 0;
		LEDR5 = 1;
		for (j=0; j<tempsledr; j++)
			{
			if (liaison == 1)
				{
				j=tempsledr;
				}	
			Delay10KTCYx(100);
			}
		LEDR5 = 0;
		LEDI5 = 1;
		for (j=0; j<tempsledi; j++)
			{
			if (liaison == 1)
				{
				j=tempsledi;
				}	
			Delay10KTCYx(100);
			}
		}
	else if (numled == 6)
		{
		LEDI6 = 0;
		LEDR6 = 1;
		for (j=0; j<tempsledr; j++)
			{
			if (liaison == 1)
				{
				j=tempsledr;
				}	
			Delay10KTCYx(100);
			}
		LEDR6 = 0;
		LEDI6 = 1;
		for (j=0; j<tempsledi; j++)
			{
			if (liaison == 1)
				{
				j=tempsledi;
				}	
			Delay10KTCYx(100);
			}
		}
	else if (numled == 7)
		{
		LEDI7 = 0;
		LEDR7 = 1;
		for (j=0; j<tempsledr; j++)
			{
			if (liaison == 1)
				{
				j=tempsledr;
				}	
			Delay10KTCYx(100);
			}
		LEDR7 = 0;
		LEDI7 = 1;
		for (j=0; j<tempsledi; j++)
			{
			if (liaison == 1)
				{
				j=tempsledi;
				}	
			Delay10KTCYx(100);
			}
		}
	else if (numled == 8)
		{
		LEDI8 = 0;
		LEDR8 = 1;
		for (j=0; j<tempsledr; j++)
			{
			if (liaison == 1)
				{
				j=tempsledr;
				}	
			Delay10KTCYx(100);
			}
		LEDR8 = 0;
		LEDI8 = 1;
		for (j=0; j<tempsledi; j++)
			{
			if (liaison == 1)
				{
				j=tempsledi;
				}	
			Delay10KTCYx(100);
			}
		}
	else if (numled == 9)
		{
		LEDI9 = 0;
		LEDR9 = 1;
		for (j=0; j<tempsledr; j++)
			{
			if (liaison == 1)
				{
				j=tempsledr;
				}	
			Delay10KTCYx(100);
			}
		LEDR9 = 0;
		LEDI9 = 1;
		for (j=0; j<tempsledi; j++)
			{
			if (liaison == 1)
				{
				j=tempsledi;
				}	
			Delay10KTCYx(100);
			}
		}
	else if (numled == 10)
		{
		LEDI1 = 0;
		LEDR1 = 1;
		LEDI2 = 0;
		LEDR2 = 1;
		LEDI3 = 0;
		LEDR3 = 1;
		LEDI4 = 0;
		LEDR4 = 1;
		LEDI5 = 0;
		LEDR5 = 1;
		LEDI6 = 0;
		LEDR6 = 1;
		LEDI7 = 0;
		LEDR7 = 1;
		LEDI8 = 0;
		LEDR8 = 1;
		LEDI9 = 0;
		LEDR9 = 1;
		for (j=0; j<tempsledr; j++)
			{
			if (liaison == 1)
				{
				j=tempsledr;
				}	
			Delay10KTCYx(100);
			}
		LEDR1 = 0;
		LEDI1 = 1;
		LEDR2 = 0;
		LEDI2 = 1;
		LEDR3 = 0;
		LEDI3 = 1;
		LEDR4 = 0;
		LEDI4 = 1;
		LEDR5 = 0;
		LEDI5 = 1;
		LEDR6 = 0;
		LEDI6 = 1;
		LEDR7 = 0;
		LEDI7 = 1;
		LEDR8 = 0;
		LEDI8 = 1;
		LEDR9 = 0;
		LEDI9 = 1;
		for (j=0; j<tempsledi; j++)
			{
			if (liaison == 1)
				{
				j=tempsledi;
				}	
			Delay10KTCYx(100);
			}
		}
	if (c[9] == 'u')
		{
		numled = 11;
		LEDR0 = 0;
   	    LEDI0 = 0;
   	    LEDR1 = 0;
   	    LEDI1 = 0;
   	    LEDR2 = 0;
   	    LEDI2 = 0;
   	    LEDR3 = 0;
   	    LEDI3 = 0;
   	    LEDR4 = 0;
   	    LEDI4 = 0;
   	    LEDR5 = 0;
   	    LEDI5 = 0;
   	    LEDR6 = 0;
   	    LEDI6 = 0;
   	    LEDR7 = 0;
   	    LEDI7 = 0;
   	    LEDR8 = 0;
   	    LEDI8 = 0;
   	    LEDR9 = 0;
   	    LEDI9 = 0;
		}
	}
}